package com.casic.dcms.mvp.model.impl;

import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.listener.OnActionResultListener;
import com.casic.dcms.mvp.model.ISubmitMaintainModel;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class SubmitMaintainModelImpl implements ISubmitMaintainModel {

    private final OnActionResultListener actionResultListener;

    public SubmitMaintainModelImpl(OnActionResultListener listener) {
        this.actionResultListener = listener;
    }

    /**
     * {@link ISubmitMaintainModel}
     */
    @Override
    public Subscription sendMaintainSubmitRequest(String bridgeId, String content, String maintainTime, String personId,
                                                  String longitude, String latitude, String description) {
        Observable<ActionResultBean> observable = RetrofitServiceManager.getAddMaintainRecordResult(bridgeId,
                content, maintainTime, personId, longitude, latitude, description);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<ActionResultBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    actionResultListener.onFailure(e);
                }
            }

            @Override
            public void onNext(ActionResultBean resultBean) {
                if (resultBean != null) {
                    actionResultListener.onSuccess(resultBean);
                }
            }
        });
    }
}
